- Qt 6.7
- Qt Serial Bus
- C++ Classes
- QCanBusFactory
- Qt 6.7.0 Reference Documentation

# QCanBusFactory Class

The QCanBusFactory class is a factory class used as the plugin interface for CAN bus plugins. More...

Header: | #include <QCanBusFactory>
CMake: | find_package(Qt6 REQUIRED COMPONENTS SerialBus) target_link_libraries(mytarget PRIVATE Qt6::SerialBus)
qmake: | QT += serialbus

- List of all members, including inherited members

## Public Functions

virtual QList<QCanBusDeviceInfo> | availableDevices(QString *errorMessage) const = 0
virtual QCanBusDevice * | createDevice(const QString &interfaceName, QString *errorMessage) const = 0

## Detailed Description

All plugins must implement the functions provided by this factory class.

## Member Function Documentation

### `[pure virtual]` QList<QCanBusDeviceInfo> QCanBusFactory::availableDevices(QString *errorMessage) const

Returns the list of available devices and their capabilities for the QCanBusDevice.

errorMessage contains an error description in case of failure.

### `[pure virtual]` QCanBusDevice *QCanBusFactory::createDevice(const QString &interfaceName, QString *errorMessage) const

Creates a new QCanBusDevice. The caller must take ownership of the returned pointer.

interfaceName is the CAN interface name and errorMessage contains an error description in case of failure.

If the factory cannot create a plugin, it returns `nullptr`.